/*
 * uuid.h -- private header file for uuids
 */
#include <sys/types.h>
#ifndef OS2
#include <linux/types.h>
#else
typedef unsigned char  __u8;
typedef unsigned short __u16;
typedef unsigned long  __u32;
#endif
#include "uuid.h"

/*
 * Offset between 15-Oct-1582 and 1-Jan-70
 */
#define TIME_OFFSET_HIGH 0x01B21DD2
#define TIME_OFFSET_LOW  0x13814000

struct uuid {
	__u32	time_low;
	__u16	time_mid;
	__u16	time_hi_and_version;
	__u16	clock_seq;
	__u8	node[6];
};


/*
 * prototypes
 */
void uuid_pack(struct uuid *uu, uuid_t ptr);
void uuid_unpack(uuid_t in, struct uuid *uu);




