/**********************************************************************/
/* REXX script to run e2fsprogs tests on OS/2                         */
/*                                                                    */
/* I wrote it mainly because I couldn't make the shells work properly */
/* with the OS/2 port of bash ... and I found faster to write this    */
/* rexx script rather than debugging the OS/2 version of bash !       */
/*                                                   M. Willm         */
/**********************************************************************/


call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
call sysloadfuncs

call SysFileTree 'f_*', test_dirs, DO

success = 0
failed  = 0

do i=1 to test_dirs.0
    dir = filespec('name', test_dirs.i)
    say 'Test ' dir ':'
    call SysFileTree dir'\script', script, FO
    if script.0 \= 0 then do
        say '    script found ... skipping'
    end; else do
        say '    script not found'
	'@gunzip <' dir'\image.gz > ' dir'\test.img'
        '@e:\mwfs\e2fsck -yf -N test_filesys ' dir'/test.img > NUL 2>&1'
        rc1 = rc
        say 'first  E2FSCK returned ' rc1
        '@e:\mwfs\e2fsck -yf -N test_filesys ' dir'/test.img > NUL 2>&1'
        rc2 = rc
        say 'second E2FSCK returned ' rc2
	'@del 'dir'\test.img'
        if (rc1 = 1) & (rc2 = 0) then do
            say 'Success !!!'
            success = success + 1
        end; else do
            say 'Failed !!!'
            failed = failed + 1
        end
    end
     
end

say '======================================'
say 'Passed : ' success
say 'Failed : ' failed
